%define __spec_install_post %{nil}

Summary:	A web-based administration interface for Unix systems.
Name:		webmin
Version:	1.480
Release:	1
License:	Freeware
Group:		System/Tools
Source:		http://www.webmin.com/download/%{name}-%{version}-minimal.tar.gz
Source1:	webmin-blue-theme.tar.bz2
BuildRoot:	%{_tmppath}/%{name}-buildroot
BuildArch:	noarch

PreReq:		/usr/bin/perl
Requires:	/usr/bin/perl
AutoReq:	0

Requires:	perl-Net-SSLeay >= 1.35
BuildRequires:	perl-Net-SSLeay >= 1.35

%description
A web-based administration interface for Unix systems. Using Webmin you can
configure DNS, Samba, NFS, local/remote filesystems and more using your
web browser. To do this, download additional modules.
After installation, enter the URL https://localhost:10000/ into your
browser and login as root with your root password.

%pre
perl <<EOD;
# maketemp.pl
# Create the /tmp/.webmin directory if needed

\$tmp_dir = \$ENV{'tempdir'} || "/tmp/.webmin";

while(\$tries++ < 10) {
	local @st = lstat(\$tmp_dir);
	exit(0) if (\$st[4] == \$< && (-d _) && (\$st[2] & 0777) == 0755);
	if (@st) {
		unlink(\$tmp_dir) || rmdir(\$tmp_dir) ||
			system("/bin/rm -rf ".quotemeta(\$tmp_dir));
		}
	mkdir(\$tmp_dir, 0755) || next;
	chown(\$<, \$(, \$tmp_dir);
	chmod(0755, \$tmp_dir);
	}
exit(1);
EOD

if [ "$?" != "0" ]; then
	echo "Failed to create or check temp files directory /tmp/.webmin"
	exit 1
fi
if [ "$tempdir" = "" ]; then
	tempdir=/tmp/.webmin
fi

perl >/$$.check <<EOD;
if (-r "/etc/.issue") {
	\$etc_issue = \`cat /etc/.issue\`;
	}
elsif (-r "/etc/issue") {
	\$etc_issue = \`cat /etc/issue\`;
	}
\$uname = \`uname -r\`;
if (\$uname =~ /2\\.6\\./) {
	print "oscheck='Generic Linux'\\n";
	}
elsif (\`uname -r\` =~ /2\\.7\\./) {
	print "oscheck='Generic Linux'\\n";
	}
EOD

. /$$.check
rm -f /$$.check
if [ ! -r /etc/webmin/config ]; then
	if [ "$oscheck" = "" ]; then
		echo Unable to identify operating system
		exit 2
	fi
#	echo Operating system is $oscheck
	if [ "$WEBMIN_PORT" != "" ]; then
		port=10000
	fi

	perl -e 'use Socket; socket(FOO, PF_INET, SOCK_STREAM, getprotobyname("tcp")); setsockopt(FOO, SOL_SOCKET, SO_REUSEADDR, pack("l", 1)); bind(FOO, pack_sockaddr_in($ARGV[0], INADDR_ANY)) || exit(1); exit(0);' $port
	if [ "$?" != "0" ]; then
		echo Port $port is already in use
		exit 2
	fi
fi

# Save /etc/webmin in case the upgrade trashes it
if [ "$1" != 1 ]; then
	rm -rf /etc/.webmin-backup
	cp -r /etc/webmin /etc/.webmin-backup
fi
/bin/true

%post
inetd=`grep "^inetd=" /etc/webmin/miniserv.conf 2>/dev/null | sed -e 's/inetd=//g'`
if [ "$1" != 1 ]; then
	# Upgrading the RPM, so stop the old webmin properly
	if [ "$inetd" != "1" ]; then
		/etc/init.d/webmin stop >/dev/null 2>&1 </dev/null
	fi
fi

#
cd /usr/lib/webmin

config_dir=/etc/webmin
var_dir=/var/webmin
perl=/usr/bin/perl
autoos=3
port=10000
login=root
crypt=x
host=`hostname`
ssl=1
atboot=1
nochown=1
autothird=1
noperlpath=1
nouninstall=1
nostart=1
tempdir=/tmp/.webmin

export config_dir var_dir perl autoos port login crypt host ssl nochown autothird noperlpath nouninstall nostart allow atboot tempdir
./setup.sh >$tempdir/webmin-setup.out 2>&1
chmod 600 $tempdir/webmin-setup.out

rm -f /var/lock/subsys/webmin

if [ "" != "1" ]; then
	/etc/init.d/webmin start >/dev/null 2>&1 </dev/null
fi

cat >/etc/webmin/uninstall.sh <<EOFF
#!/bin/sh
printf "Are you sure you want to uninstall Webmin? (y/n) : "
read answer
printf "\n"
if [ "\$answer" = "y" ]; then
	echo "Removing webmin RPM .."
	rpm -e --nodeps webmin
	echo "Done!"
fi
EOFF
chmod +x /etc/webmin/uninstall.sh

port=`grep "^port=" /etc/webmin/miniserv.conf | sed -e 's/port=//g'`
perl -e 'use Net::SSLeay' >/dev/null 2>/dev/null

sslmode=0
if [ "$?" = "0" ]; then
	grep ssl=1 /etc/webmin/miniserv.conf >/dev/null 2>/dev/null
	if [ "$?" = "0" ]; then
		sslmode=1
	fi
fi

musthost=`grep musthost= /etc/webmin/miniserv.conf | sed -e 's/musthost=//'`
if [ "" != "" ]; then
	host=
fi

#if [ "$sslmode" = "1" ]; then
#	echo "Webmin install complete. You can now login to https://$host:$port/"
#	echo "as root with your root password."
#else
#	echo "Webmin install complete. You can now login to http://$host:$port/"
#	echo "as root with your root password."
#fi
/bin/true

%preun
if [ "$1" = 0 ]; then
	grep root=/usr/lib/webmin /etc/webmin/miniserv.conf >/dev/null 2>&1
	if [ "$?" = 0 ]; then
		# RPM is being removed, and no new version of webmin
		# has taken it's place. Run uninstalls and stop the server
#		echo "Running uninstall scripts .."
		(cd /usr/lib/webmin ; WEBMIN_CONFIG=/etc/webmin WEBMIN_VAR=/var/webmin LANG= /usr/lib/webmin/run-uninstalls.pl)
		/etc/init.d/webmin stop >/dev/null 2>&1 </dev/null
		/etc/webmin/stop >/dev/null 2>&1 </dev/null
	fi
fi
/bin/true

%postun
if [ "$1" = 0 ]; then
	grep root=/usr/lib/webmin /etc/webmin/miniserv.conf >/dev/null 2>&1
	if [ "$?" = 0 ]; then
		# RPM is being removed, and no new version of webmin
		# has taken it's place. Delete the config files
		rm -rf /etc/webmin /var/webmin
	fi
fi
/bin/true

%triggerpostun -- webmin
if [ ! -d /var/webmin -a "$1" = 2 ]; then
#	echo Re-creating /var/webmin directory
	mkdir /var/webmin
fi
if [ ! -r /etc/webmin/miniserv.conf -a -d /etc/.webmin-backup -a "$1" = 2 ]; then
#	echo Recovering /etc/webmin directory
	rm -rf /etc/.webmin-broken
	mv /etc/webmin /etc/.webmin-broken
	mv /etc/.webmin-backup /etc/webmin
	/etc/init.d/webmin stop >/dev/null 2>&1 </dev/null
	/etc/init.d/webmin start >/dev/null 2>&1 </dev/null
else
	rm -rf /etc/.webmin-backup
fi
/bin/true

%prep
%setup -q
tar xfj %{SOURCE1}

%build
(find . -name '*.cgi' ; find . -name '*.pl') | perl perlpath.pl /usr/bin/perl -
rm -Rf acl/Authen-SolarisRBAC-0.1/
rm -f acl/Authen-SolarisRBAC-0.1.tar.gz
rm -f webmin-gentoo-init
rm -f webmin-caldera-init
chmod -R og-w .

%install
rm -Rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/lib/webmin
mkdir -p $RPM_BUILD_ROOT/etc/sysconfig/daemons
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/{rc0.d,rc1.d,rc2.d,rc3.d,rc5.d,rc6.d}
mkdir -p $RPM_BUILD_ROOT/etc/init.d
mkdir -p $RPM_BUILD_ROOT/etc/pam.d
cp -rp * $RPM_BUILD_ROOT/usr/lib/webmin
cp webmin-daemon $RPM_BUILD_ROOT/etc/sysconfig/daemons/webmin
cp webmin-init $RPM_BUILD_ROOT/etc/init.d/webmin
cp webmin-pam $RPM_BUILD_ROOT/etc/pam.d/webmin
ln -s /etc/init.d/webmin $RPM_BUILD_ROOT/etc/rc.d/rc2.d/S99webmin
ln -s /etc/init.d/webmin $RPM_BUILD_ROOT/etc/rc.d/rc3.d/S99webmin
ln -s /etc/init.d/webmin $RPM_BUILD_ROOT/etc/rc.d/rc5.d/S99webmin
ln -s /etc/init.d/webmin $RPM_BUILD_ROOT/etc/rc.d/rc0.d/K10webmin
ln -s /etc/init.d/webmin $RPM_BUILD_ROOT/etc/rc.d/rc1.d/K10webmin
ln -s /etc/init.d/webmin $RPM_BUILD_ROOT/etc/rc.d/rc6.d/K10webmin
echo rpm >$RPM_BUILD_ROOT/usr/lib/webmin/install-type

%clean
rm -Rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%_libdir/webmin
%config /etc/sysconfig/daemons/webmin
/etc/init.d/webmin
/etc/rc.d/rc2.d/S99webmin
/etc/rc.d/rc3.d/S99webmin
/etc/rc.d/rc5.d/S99webmin
/etc/rc.d/rc0.d/K10webmin
/etc/rc.d/rc1.d/K10webmin
/etc/rc.d/rc6.d/K10webmin
%config /etc/pam.d/webmin

%changelog
* Fri Aug 14 2009 Christian Wasem <wasem@ccux-linux.de> 1.480-1
- Initial Release
